# Robert Meolic, 2016

outline ""
outline "CHECKING FOR INDEPENDENCE SETS AND MAXIMUM INDEPENDENCE SETS"
outline "(MAXIMUM INDEPENDENCE SETS ARE ALSO CALLED KERNELS)"
outline ""

# Original graph is a 3-regular 6-graph from http://arxiv.org/pdf/0910.4664.pdf
#
# Edge list
# 1 2
# 1 4
# 1 6
# 2 3
# 2 6
# 3 4
# 3 5
# 4 5
# 5 6
#
# Adjacency lists
# 1 -> 2 4 6
# 2 -> 1 3 6
# 3 -> 2 4 5
# 4 -> 1 3 5
# 5 -> 3 4 6
# 6 -> 1 2 5

bdd_terminals "z1 z2 z3 z4 z5 z6"

bdd_eval1 "(OR z2 z4 z6)" a1
bdd_eval1 "(OR z1 z3 z6)" a2
bdd_eval1 "(OR z2 z4 z5)" a3
bdd_eval1 "(OR z1 z3 z5)" a4
bdd_eval1 "(OR z3 z4 z6)" a5
bdd_eval1 "(OR z1 z2 z5)" a6

bdd_eval1 "(0)" R
bdd_eval1 "(OR R (AND z1 a1))" R
bdd_eval1 "(OR R (AND z2 a2))" R
bdd_eval1 "(OR R (AND z3 a3))" R
bdd_eval1 "(OR R (AND z4 a4))" R
bdd_eval1 "(OR R (AND z5 a5))" R
bdd_eval1 "(OR R (AND z6 a6))" R
bdd_eval1 "(NOT R)" R

bdd_out_function R

out "NUMBER OF INDEPENDENCE SETS: "
outline [bdd_minterm_count R]
out "REPRESENTED WITH "
out [bdd_node_number R]
outline " BDD NODES"
outline ""

bdd_eval1 "(0)" K
bdd_eval1 "(OR K (NOT (EXOR z1 a1)))" K
bdd_eval1 "(OR K (NOT (EXOR z2 a2)))" K
bdd_eval1 "(OR K (NOT (EXOR z3 a3)))" K
bdd_eval1 "(OR K (NOT (EXOR z4 a4)))" K
bdd_eval1 "(OR K (NOT (EXOR z5 a5)))" K
bdd_eval1 "(OR K (NOT (EXOR z6 a6)))" K
bdd_eval1 "(NOT K)" K

bdd_out_function K

out "NUMBER OF KERNELS: "
outline [bdd_minterm_count K]
out "REPRESENTED WITH "
out [bdd_node_number K]
outline " BDD NODES"

#FURTHER WORK
#use a contiguous USA graph
#http://www-cs-staff.stanford.edu/~uno/contiguous-usa.dat
