# Robert Meolic, 12.7.2016

ccs_read lactose-fullspec.ccs
ccs_read lactose-sysspec.ccs

# PLEASE NOTE
# processes Ent, Neg, and Pos are already encoded by CCS parser
# (the instances made by CCS parser are named Ent#1, Neg#1, and Pos#1)
# however, internal processes created by CCS parser are not intended for
# general use (the implementation of CCS parser may change!), thus we
# use the original processes which should be explicitely encoded before use

pa_encode_process "Ent Neg Pos"

# PLEASE NOTE
# If you want to get the time for the composition only then you can use
# the following command:
#
#versis_compose 2 SpecFull \
#  "Ent Beta_galactosidase_low Allolactose_none Neg Promoter_iu Pos Glucose_high" \
#  "rbeta iallo ibeta iglu dbeta ballo rep urep act iact lev low high"

outline "SIZE OF PROCESSES (states/transitions)"
outline ""

out "Process Ent (==SpecEntrance): "
out [pa_state_number Ent]
out "/"
out [pa_transition_number Ent]
out " ("
out [pa_transition_visible Ent]
out " visible transitions)"
outline ""

out "Process SysEntrance: "
out [pa_state_number SysEntrance]
out "/"
out [pa_transition_number SysEntrance]
out " ("
out [pa_transition_visible SysEntrance]
out " visible transitions)"
outline ""

versis_strong_equivalence 0 Ent 0 SysEntrance
versis_weak_equivalence 0 Ent 0 SysEntrance
versis_testing_equivalence 0 Ent 0 SysEntrance
versis_trace_equivalence 0 Ent 0 SysEntrance
outline ""

out "Process Neg (==SpecNegReg): "
out [pa_state_number Neg]
out "/"
out [pa_transition_number Neg]
out " ("
out [pa_transition_visible Neg]
out " visible transitions)"
outline ""

out "Process SysNegReg: "
out [pa_state_number SysNegReg]
out "/"
out [pa_transition_number SysNegReg]
out " ("
out [pa_transition_visible SysNegReg]
out " visible transitions)"
outline ""

versis_strong_equivalence 0 Neg 0 SysNegReg
versis_weak_equivalence 0 Neg 0 SysNegReg
versis_testing_equivalence 0 Neg 0 SysNegReg
versis_trace_equivalence 0 Neg 0 SysNegReg
outline ""

out "Process Pos (==SpecPosReg): "
out [pa_state_number Pos]
out "/"
out [pa_transition_number Pos]
out " ("
out [pa_transition_visible Pos]
out " visible transitions)"
outline ""

out "Process SysPosReg: "
out [pa_state_number SysPosReg]
out "/"
out [pa_transition_number SysPosReg]
out " ("
out [pa_transition_visible SysPosReg]
out " visible transitions)"
outline ""

versis_strong_equivalence 0 Pos 0 SysPosReg
versis_weak_equivalence 0 Pos 0 SysPosReg
versis_testing_equivalence 0 Pos 0 SysPosReg
versis_trace_equivalence 0 Pos 0 SysPosReg
outline ""

out "Composition SpecFull: "
out [pa_comp_state_number SpecFull]
out "/"
out [pa_comp_transition_number SpecFull]
out " ("
out [pa_comp_transition_visible SpecFull]
out " visible transitions)"
outline ""

out "Composition SystemFull: "
out [pa_comp_state_number SystemFull]
out "/"
out [pa_comp_transition_number SystemFull]
out " ("
out [pa_comp_transition_visible SystemFull]
out " visible transitions)"
outline ""

#versis_strong_minimization 1 SpecFull
#out "Process STRONG_SpecFull: "
#out [pa_state_number STRONG_SpecFull]
#out "/"
#out [pa_transition_number STRONG_SpecFull]
#out " ("
#out [pa_transition_visible STRONG_SpecFull]
#out " visible transitions)"
#outline ""

#versis_strong_minimization 1 SystemFull
#out "Process STRONG_SystemFull: "
#out [pa_state_number STRONG_SystemFull]
#out "/"
#out [pa_transition_number STRONG_SystemFull]
#out " ("
#out [pa_transition_visible STRONG_SystemFull]
#out " visible transitions)"
#outline ""
