@echo off

REM  This file is part of EST (Efficient Symbolic Tools).
REM  Copyright (C) 2003, 2016
REM  UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
REM
REM  EST is free software; you can redistribute it and/or modify
REM  it under the terms of the GNU General Public License as
REM  published by the Free Software Foundation; either version 2
REM  of the License, or (at your option) any later version.
REM
REM  EST is distributed in the hope that it will be useful,
REM  but WITHOUT ANY WARRANTY; without even the implied warranty of
REM  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
REM  GNU General Public License for more details.
REM
REM  You should have received a copy of the GNU General Public
REM  License along with this program; if not, write to the Free
REM  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
REM  Boston, MA 02110-1301 USA.]

REM this script expects Biddy library in your path
REM usually, we provide dynamic library (DLL) in ../biddy/bin
REM you should delete libbiddy.a from ../biddy/bin to use dll

SET CFLAGS=

REM SET PLATFORM=32
REM SET SFX="C:\Program Files\7-Zip\7zsd_All.sfx"

SET PLATFORM=64
SET SFX="C:\Program Files\7-Zip\7zsd_All_x64.sfx"

SET EDITION=est-2ed
SET FOLDER=est
FOR /F "USEBACKQ" %%T IN (`TYPE source\VERSION`) DO SET VVERSION=%%T
SET VERSION=%VVERSION:.=-%
SET OS=Win
SET BBINDIR="%cd%\bin"
SET BINDIR=%BBINDIR:\=/%
SET MYZIP="C:\Program Files\7-Zip\7z.exe" a

SET NAME=EST, 2nd Edition
SET RELEASE=Release: %VVERSION%  (%DATE%)

rm %EDITION%-%VERSION%-%OS%-mish.7z
rm %EDITION%-%VERSION%-%OS%-mish.exe
rm %EDITION%-%VERSION%-%OS%.7z
rm %EDITION%-%VERSION%-%OS%.exe
rm -fr bin

echo Creating %EDITION%-%VERSION%-%OS%-mish

cd source
make sockets "CFLAGS = %CFLAGS%" "BINDIR=%BINDIR%"
make clean "CFLAGS = %CFLAGS%" "BINDIR=%BINDIR%"
cp COPYING ../bin
cp est2ed.tcl ../bin
cp estsh2ed.tcl ../bin
cp est2edserver.tcl ../bin
cp pkgIndex.tcl ../bin
cp ../myinterface/mi.tcl ../bin
cp ../myinterface/miDialog.tcl ../bin
cp ../../biddy/bddview/bddview.tcl ../bin
cp bdd/bddDialog.tcl ../bin
cp pa/paDialog.tcl ../bin
cp versis/versisDialog.tcl ../bin
cp mc/mcDialog.tcl ../bin
cp strucval/strucvalDialog.tcl ../bin
cp ccs/ccsDialog.tcl ../bin
cp ../etc/est-bw.ico ../bin
make milocal "CFLAGS = %CFLAGS%" "BINDIR=%BINDIR%"
cd ..

REM est2ed.exe is broken with tcl8.6
rm ./bin/est2ed.exe

%MYZIP% %EDITION%-%VERSION%-%OS%-mish.7z .\bin\* -x!.\bin\*.a
%MYZIP% %EDITION%-%VERSION%-%OS%-mish.7z .\etc\* -x!.\etc\.svn
%MYZIP% %EDITION%-%VERSION%-%OS%-mish.7z .\data\* -x!.\data\.svn -x!.\data\*\.svn

echo Packaging %EDITION%-%VERSION%-%OS%-mish.exe ...

echo ;!@Install@!UTF-8! > cfg.cfg
echo Title="Efficient Symbolic Tools package" >> cfg.cfg
echo BeginPrompt="Efficient Symbolic Tools package (%PLATFORM%-bit interactive version)\nVersion %VVERSION%\n\nThis is binary distribution of %NAME%.\n\nThis is free software. See GNU GPL (version 2).\n\nYou need ActiveTcl installed on your computer.\n\nNOTE: No registry entry will be changed and no file will be\n           created outside the target folder. You can uninstall\n           this software by simply deleting the target folder.\n\nRobert Meolic (robert.meolic@um.si)" >> cfg.cfg
echo ExtractPathText="Please, enter EMPTY OR NONEXISTENT target folder:" >> cfg.cfg
echo ExtractDialogText="Please, wait..." >> cfg.cfg
echo ExtractTitle="Extracting..." >> cfg.cfg
echo GUIFlags="8+32+64+256+4096" >> cfg.cfg
echo GUIMode="1" >> cfg.cfg
echo InstallPath="%HOMEPATH%\\est2ed" >> cfg.cfg
echo ;!@InstallEnd@! >> cfg.cfg

copy /b /y %SFX% + cfg.cfg + "%EDITION%-%VERSION%-%OS%-mish.7z" "%EDITION%-%VERSION%-%OS%-mish.exe"

rm %EDITION%-%VERSION%-%OS%-mish.7z
rm -fr bin

echo Creating %EDITION%-%VERSION%-%OS% ...

cd source
make lib "CFLAGS = %CFLAGS%" "BINDIR=%BINDIR%"
make clean "CFLAGS = %CFLAGS%" "BINDIR=%BINDIR%"
cp COPYING ../bin
cp est.h ../bin
cd ../..

%MYZIP% %FOLDER%\%EDITION%-%VERSION%-%OS%.7z %FOLDER%\bin\*

cd %FOLDER%\source
make staticlib "CFLAGS = %CFLAGS%" "BINDIR=%BINDIR%"
make clean "CFLAGS = %CFLAGS%" "BINDIR=%BINDIR%"
cd ../..

%MYZIP% %FOLDER%\%EDITION%-%VERSION%-%OS%.7z %FOLDER%\bin\libest2.a

cd %FOLDER%
rm -fr bin

cd ..

%MYZIP% %FOLDER%\%EDITION%-%VERSION%-%OS%.7z %FOLDER%\projects\* -x!%FOLDER%\projects\.svn -x!%FOLDER%\projects\.svn -x!%FOLDER%\projects\*\.svn

cd %FOLDER%

echo Packaging %EDITION%-%VERSION%-%OS%.exe ...

echo ;!@Install@!UTF-8! > cfg.cfg
echo Title="Efficient Symbolic Tools package" >> cfg.cfg
echo BeginPrompt="Efficient Symbolic Tools package (%PLATFORM%-bit libraries and projects)\nVersion %VVERSION%\n\nThis is free software. See GNU GPL (version 2).\n\nNOTE: No registry entry will be changed and no file will be\n           created outside the target folder. You can uninstall\n           this software by simply deleting the target folder.\n\nRobert Meolic (robert.meolic@um.si)" >> cfg.cfg
echo ExtractPathText="Please, enter EMPTY OR NONEXISTENT target folder:" >> cfg.cfg
echo ExtractDialogText="Please, wait..." >> cfg.cfg
echo ExtractTitle="Extracting..." >> cfg.cfg
echo GUIFlags="8+32+64+256+4096" >> cfg.cfg
echo GUIMode="1" >> cfg.cfg
echo InstallPath="%HOMEPATH%\\libest2" >> cfg.cfg
echo ;!@InstallEnd@! >> cfg.cfg

copy /b /y %SFX% + cfg.cfg + "%EDITION%-%VERSION%-%OS%.7z" "%EDITION%-%VERSION%-%OS%.exe"

rm %EDITION%-%VERSION%-%OS%.7z
rm -f cfg.cfg

echo *******************
echo PACKAGES COMPLETED!
echo *******************
