/**CHeaderFile*************************************************************
  PackageName [gui]
  Synopsis    [Package 'gui' is used to redirect output to GUI.]

  FileName    [gui.h]
  Revision    [$Revision: 113 $]
  Date        [$Date: 2016-03-08 22:31:16 +0100 (tor, 08 mar 2016) $]
  Authors     [Robert Meolic (robert.meolic@um.si)]
  Description [File guiInt.h contains declaration of internal
               data structures.]
  SeeAlso     [gui.h]

  Copyright   [This file is part of EST (Efficient Symbolic Tools).
               Copyright (C) 2003, 2016
               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia

               EST is free software; you can redistribute it and/or modify
               it under the terms of the GNU General Public License as
               published by the Free Software Foundation; either version 2
               of the License, or (at your option) any later version.

               EST is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
               Boston, MA 02110-1301 USA.]
  ************************************************************************/

#ifndef _GUIINT
#define _GUIINT

#include "gui.h"

/* if using sockets then printf("\n") will produce two new lines */
/* you will avoid this efect by using printf(NEWLINE) which adds extra space */
/* this extra space is not needed if counting bytes mechanism is used */
#ifdef USESOCKETS
#  ifdef ESTWIN32
#    define printf(...) {char sendbuf[1024]; sprintf(sendbuf,__VA_ARGS__);if(gui_outputLength<0){send(gui_outputStream,sendbuf,(int)strlen(sendbuf),0);}else{gui_outputLength+=send(gui_outputStream,sendbuf,(int)strlen(sendbuf),0);}send(gui_outputStream,"\n",1,0);Gui_Update();}
#  else
#    define printf(...) {if(gui_outputLength<0){fprintf(gui_outputStream,__VA_ARGS__);}else{gui_outputLength+=fprintf(gui_outputStream,__VA_ARGS__);}fprintf(gui_outputStream,"\n");Gui_Update();}
#    define debugprintf(...) {fprintf(stderr,"GUI[");fprintf(stderr,__VA_ARGS__);fprintf(stderr,"]");if(gui_outputLength<0){fprintf(gui_outputStream,__VA_ARGS__);}else{gui_outputLength+=fprintf(gui_outputStream,__VA_ARGS__);}fprintf(gui_outputStream,"\n");Gui_Update();}
#  endif
#  define NEWLINE " \n"
#else
#  define NEWLINE "\n"
#endif


/*-----------------------------------------------------------------------*/
/* Constant declarations                                                 */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* Variable declarations                                                 */
/*-----------------------------------------------------------------------*/

/**AutomaticStart*********************************************************/

/*-----------------------------------------------------------------------*/
/* Function prototypes                                                   */
/*-----------------------------------------------------------------------*/

/**AutomaticEnd***********************************************************/

#endif  /* _GUIINT */
