/**CHeaderFile*************************************************************
  PackageName [strucval]
  Synopsis    [Structure-driven validation of hardware and software systems]

  FileName    [strucvalInt.h]
  Revision    [$Revision: 113 $]
  Date        [$Date: 2016-03-08 22:31:16 +0100 (tor, 08 mar 2016) $]
  Authors     [Robert Meolic (robert.meolic@um.si)]
  Description [File strucvalInt.h contains declaration of all internal
               data structures.]
  SeeAlso     [strucval.h]

  Copyright   [This file is part of EST (Efficient Symbolic Tools).
               Copyright (C) 2003, 2016
               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia

               EST is free software; you can redistribute it and/or modify
               it under the terms of the GNU General Public License as
               published by the Free Software Foundation; either version 2
               of the License, or (at your option) any later version.

               EST is distributed in the hope that it will be useful,
               but WITHOUT ANY WARRANTY; without even the implied warranty of
               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
               GNU General Public License for more details.

               You should have received a copy of the GNU General Public
               License along with this program; if not, write to the Free
               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
               Boston, MA 02110-1301 USA.]
  ************************************************************************/

#ifndef _STRUCVALINT
#define _STRUCVALINT

#include "strucval.h"

#ifdef USE_BDD_STUBS
#  include <bddDecls.h>
#endif

#ifdef USE_PA_STUBS
#  include <paDecls.h>
#endif

#ifdef USE_VERSIS_STUBS
#  include <versisDecls.h>
#endif

#ifdef USE_MC_STUBS
#  include <mcDecls.h>
#endif

/* if using sockets then printf("\n") will produce two new lines */
/* you will avoid this efect by using printf(NEWLINE) which adds extra space */
/* this extra space is not needed if counting bytes mechanism is used */
#ifdef USESOCKETS
#  include <gui.h>
#  ifdef USE_GUI_STUBS
#    include <guiDecls.h>
#  endif
#  ifdef ESTWIN32
#    define printf(...) {char sendbuf[1024]; sprintf(sendbuf,__VA_ARGS__);if(gui_outputLength<0){send(gui_outputStream,sendbuf,(int)strlen(sendbuf),0);}else{gui_outputLength+=send(gui_outputStream,sendbuf,(int)strlen(sendbuf),0);}send(gui_outputStream,"\n",1,0);Gui_Update();}
#  else
#    define printf(...) {if(gui_outputLength<0){fprintf(gui_outputStream,__VA_ARGS__);}else{gui_outputLength+=fprintf(gui_outputStream,__VA_ARGS__);}fprintf(gui_outputStream,"\n");Gui_Update();}
#    define debugprintf(...) {fprintf(stderr,"STRUCVAL[");fprintf(stderr,__VA_ARGS__);fprintf(stderr,"]");if(gui_outputLength<0){fprintf(gui_outputStream,__VA_ARGS__);}else{gui_outputLength+=fprintf(gui_outputStream,__VA_ARGS__);}fprintf(gui_outputStream,"\n");Gui_Update();}
#  endif
#  define NEWLINE " \n"
#else
#  define NEWLINE "\n"
#endif

/*-----------------------------------------------------------------------*/
/* Constant declarations                                                 */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* Structure declarations                                                */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* Variable declarations                                                 */
/*-----------------------------------------------------------------------*/

/**AutomaticStart*********************************************************/

/*-----------------------------------------------------------------------*/
/* Function prototypes                                                   */
/*-----------------------------------------------------------------------*/

extern void Strucval_SyncProduct_Thr(Est_String name, Est_String lts,
				 Est_String wca, Est_String actions);

extern void StrucvalReduceStates(Pa_Composition *c, Bdd_Edge finalBddWCA);

/**AutomaticEnd***********************************************************/

#endif  /* _STRUCVALINT */
